//
//  RestParser.h
//
//  Created by Setsu on 4/24/10.
//  Copyright 2010 RoundSquare Inc. All rights reserved.
//
// Permission is hereby granted, free of charge, to any person or organization
// obtaining a copy of the software and accompanying documentation covered by
// this license (the "Software") to use, reproduce, display, distribute,
// execute, and transmit the Software, and to prepare derivative works of the
// Software, and to permit third-parties to whom the Software is furnished to
// do so, all subject to the following:
// 
// The copyright notices in the Software and this entire statement, including
// the above license grant, this restriction and the following disclaimer,
// must be included in all copies of the Software, in whole or in part, and
// all derivative works of the Software, unless such copies or derivative
// works are solely in the form of machine-executable object code generated by
// a source language processor.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
// SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
// FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.
//

#ifndef REST_PARSER_H
#define REST_PARSER_H

//----------------------------------------
//	include
//----------------------------------------
#include <string>
#include <map>
#include <memory>

//----------------------------------------
//	RestParser
//----------------------------------------
class RestParser
{
public:
	RestParser(const std::string& urlStr);
	~RestParser();
	int GetURL(std::string& url) const;
	int GetKeyValues(std::map<std::string, std::string>& keyValues) const;

private:
	RestParser();
	RestParser(const RestParser&);
	RestParser& operator = (const RestParser&);

	class RestParserImpl;
	std::auto_ptr<RestParserImpl>	m_pImpl;
};

#endif	// REST_PARSER_H
